		EJECT
;****************************************
;*					*
;*	AT24Cxx Driver			*
;*	Stand: 7.3.2005			*
;*					*
;****************************************

;-------------------------------------------------------------------------------		
		Public	AT24_Write	;AT24[DPTR] := A
		Public	AT24_BlockWrite	;AT24[DPTR] := B*@R0
		Public	AT24_Read	;A   :=   AT24[DPTR]
		Public	AT24_BlockRead	;@R0 := B*AT24[DPTR]
		Public	AT24_Init	;Init I2C
AT24_Typ	EQU	24512
AT24_SCL	EQU	0
AT24_SDA	EQU	0
;-------------------------------------------------------------------------------		
;		List	Off
;-------------------------------------------------------------------------------
;
;	         --_--
;	E0   1 -|  A  |- 8 Vcc
;	        |  T  |
;	E1   2 -|  2  |- 7 /WC
;	        |  4  |
;	E2   3 -|  C  |- 6 SCL
;	        |  x  |
; 	GND  4 -|  x  |- 5 SDA
;	         -----        
;
;		b7 b6 b5 b4 b3  b2 b1 b0	    AdrLo	Daten	
;24C01	 	1  0  1  0   E2 E1 E0 RW	    00xxxxxx
;24C02		1  0  1  0   E2 E1 E0 RW	    0xxxxxxx
;24C04		1  0  1  0   E2 E1 A8 RW	    xxxxxxxx
;24C08		1  0  1  0   E2 A9 A8 RW	    xxxxxxxx
;24C16		1  0  1  0  A10 A9 A8 RW	    xxxxxxxx
;					  AdrHi	    AdrLo	Daten
;24C32		1  0  1  0   E2 E1 E0 RW  0000xxxx
;24C64		1  0  1  0   E2 E1 E0 RW  000xxxxx
;24C128		1  0  1  0    0 E1 E0 RW  00xxxxxx
;24C256		1  0  1  0    0 E1 E0 RW  0xxxxxxx
;24C512		1  0  1  0    0 E1 E0 RW  xxxxxxxx
;24C1024	1  0  1  0    0 A1 E0 RW
;-------------------------------------------------------------------------------
; @R0 := B*AT24[DPTR]
	Cond	?AT24_BlockRead
AT24_BlockRead:	Push	B
		Call	I2C_Adresse
		Mov	A, #0A1H	;DeviceID+Read
		Call	I2C_Go
		JMP	AT24_BR1

AT24_BR2:	Push	B
		Clr	C		;ACK
		Call	I2C_Put
AT24_BR1:	Call	I2C_Read	;Data
		Mov	@R0, A
		Inc	R0
		POP	B
		DJNZ	B, AT24_BR2	;EndOfBlock
		Push	B
		JMP	AT24_BR3
	EndC
;-------------------------------------------------------------------------------
; A := AT24[DPTR]
AT24_Read:	Push	B
		Call	I2C_Adresse
		Mov	A, #0A1H	;DeviceID+Read
		Call	I2C_Go
		Call	I2C_Read	;Data
AT24_BR3:	SetB	C		;no ACK
		Call	I2C_Put
		JMP	AT24_Stop
;-------------------------------------------------------------------------------
; AT24[DPTR] := B*@R0
; B <= 127	24C512
; B <=  64	24C128,24C256
	Cond	?AT24_BlockWrite
AT24_BlockWrite:Push	B
		Call	I2C_Adresse
AT24_BW1:	Mov	A, @R0
		Inc	R0
		Call	I2C_Write
		DJNZ	AT24_BW1
		JMP	AT24_Stop
	EndC
;-------------------------------------------------------------------------------		
; AT24[DPTR] := A
AT24_Write:	Push	B, A
		Call	I2C_Adresse
		POP	A		;Data
		Call	I2C_Write
;-------------------------------------------------------------------------------
;ansteigende Flanke von SDA, wenn SCL auf High
AT24_Stop:	Clr	AT24_SDA
		POP	B
AT24_Init: 	SetB	AT24_SCL
		SetB	AT24_SDA	;L->H Flanke Stop-Condition
		Ret
;-------------------------------------------------------------------------------
; A := [Bus]
I2C_Read:	Mov	B, #8
Loop_Read:      Call	I2C_Get
		Rlc	A
		Djnz	B, Loop_Read
		Ret
;-------------------------------------------------------------------------------
;abfallende Flanke  von SDA ,whrend SCL auf High
I2C_Start:	SetB	AT24_SDA
		SetB	AT24_SCL
	  	Clr	AT24_SDA	;H->L Flanke Start-Condition
		Clr	AT24_SCL	;vorbereiten fr Daten
		Ret
;-------------------------------------------------------------------------------		
;IN:	DPTR	Adresse
I2C_Adresse:	Mov	A, #0A0H	;DeviceID+Write
		Call	I2C_Go
		COND	AT24_Typ > 2416
		 Mov	 A, DPH		;AdrHi
		 Call	 I2C_Write
		EndC
		Mov	A, DPL		;AdrLo
		JMP	I2C_Write
;-------------------------------------------------------------------------------
I2C_Go:		Call	I2C_Start
		COND	AT24_Typ < 2432
		 MOV	 B, A
		 Mov	 A, DPH		;AdrHi
		 Anl	 A, #0111B
		 RL	 A
		 Orl	 A, B
		EndC
;-------------------------------------------------------------------------------
;IN:		Bus := [A]
;OUT:		CY  := ACK
I2C_Write:	Mov	B, #8
Loop_Write:	RlC	A
		Call	I2C_Put
		Djnz	B, Loop_Write
;-------------------------------------------------------------------------------		
; C := SDA
I2C_Get:	SetB	AT24_SDA
		SetB	AT24_SCL
       		Mov	C, AT24_SDA
		Clr	AT24_SCL
		RET
;-------------------------------------------------------------------------------
; SDA := C
I2C_Put:	MOV	AT24_SDA, C
		SetB	AT24_SCL
		Clr	AT24_SCL
		Clr	AT24_SDA
		Ret
;-------------------------------------------------------------------------------		
