;Macros, Stand 21.7.2012 by Peter Lindow
		LIST	OFF		;nicht anzeigen
;--------------------------------------
;Compare And Jump Equal
CJE		MACRO	Register, Value, Target
		CJNE	Register, Value, @@1
		JMP	Target
@@1:		ENDM
;--------------------------------------
;Compare And Jump Less
CJL		MACRO	Register, Value, Target
		CJNE	Register, Value, @@1
@@1:		JC_	Target
		ENDM
;--------------------------------------
;Compare And Jump Less Or Equal
CJLE		MACRO	Register, Value, Target
		CJNE	Register, Value, @@1
		SETB	C
@@1:		JC_	Target
		ENDM
;--------------------------------------
;Compare And Jump Greater
CJG		MACRO	Register, Value, Target
		CJNE	Register, Value, @@1
		JMP	@@2
@@1:		JNC_	Target
@@2:		ENDM
;--------------------------------------
;Compare And Jump Greater Or Equal
CJGE		MACRO	Register, Value, Target
		CJNE	Register, Value, @@1
@@1:		JNC_	Target
		ENDM
;--------------------------------------
;Jump if Not Bit is set, else Clear bit
JNBC		MACRO	BIT, Target
		JBC	BIT, @@1
		JMP	Target
@@1:		ENDM
;--------------------------------------
;Jump if Signum
JS		Macro	Value, Target
		MOV	A, Value
		JB_	A.7, Target
		EndM
;--------------------------------------
;Jump if Not Signum
JnS		Macro	Value, Target
		MOV	A, Value
		JNB_	A.7, Target
		EndM
;--------------------------------------
;Long Jump Bit
JB_		MACRO	Value, Target
	Cond	((Target-$) > -128) & ((Target-$) < 128)
		JB	Value, Target
	Else
		JnB	Value, @@1
		JMP	Target
@@1:	EndC
		ENDM
;--------------------------------------
;Long Jump NOT Bit
JNB_		MACRO	Value, Target
	Cond	((Target-$) > -128) & ((Target-$) < 128)
		JnB	Value, Target
	Else
		JB	Value, @@1
		JMP	Target
@@1:	EndC
		ENDM
;--------------------------------------
;Long Jump Zero
JZ_		MACRO	Target
	Cond	((Target-$) > -128) & ((Target-$) < 128)
		JZ	Target
	Else
		JnZ	@@1
		JMP	Target
@@1:	EndC
		ENDM
;--------------------------------------
;Long Jump Not Zero
JNZ_		MACRO	Target
	Cond	((Target-$) > -128) & ((Target-$) < 128)
		JnZ	Target
	Else
		JZ	@@1
		JMP	Target
@@1:	EndC
		ENDM
;--------------------------------------
;Long Jump Carry
JC_		MACRO	Target
	Cond	((Target-$) > -128) & ((Target-$) < 128)
		JC	Target
	Else
		JnC	@@1
		JMP	Target
@@1:	EndC
		ENDM
;--------------------------------------
;Long Jump Not Carry
JNC_		MACRO	Target
	Cond	((Target-$) > -128) & ((Target-$) < 128)
		JnC	Target
	Else
		JC	@@1
		JMP	Target
@@1:	EndC
		ENDM
;--------------------------------------
;Return if A=0
RETZ		MACRO
		JnZ	@@1
		RET
@@1:		ENDM
;--------------------------------------
;Return if A<>0
RETNZ		MACRO
		JZ	@@1
		RET
@@1:		ENDM
;--------------------------------------
;Return Carry
RETC		MACRO
		JnC	@@1
		RET
@@1:		ENDM
;--------------------------------------
;Return NOT Carry
RETNC		MACRO
		JC	@@1
		RET
@@1:		ENDM
;--------------------------------------
;Return Bit
RETB		MACRO	Value
		JnB	Value, @@1
		RET
@@1:		ENDM
;--------------------------------------
;Return NOT Bit
RETNB		MACRO	Value
		JB	Value, @@1
		RET
@@1:		ENDM
;--------------------------------------
RRC_		Macro	Register
		XCH	A, Register
		RRC	A
		XCH	A, Register
		EndM
;--------------------------------------
RLC_		Macro	Register
		XCH	A, Register
		RLC	A
		XCH	A, Register
		EndM
;--------------------------------------
CPL_		Macro	Register
		XCH	A, Register
		CPL	A
		XCH	A, Register
		EndM
;--------------------------------------
ADD_		Macro	Register, Value
		XCH	A, Register
		ADD	A, Value
		XCH	A, Register
		EndM
;--------------------------------------
SUB_		Macro	Register, Value
		CLR	C
		MOV	A, Register
		SUBB	A, Value
		EndM
;--------------------------------------
ADDC_		Macro	Register, Value
		XCH	A, Register
		ADDC	A, Value
		XCH	A, Register
		EndM
;--------------------------------------
SUBB_		Macro	Register, Value
		XCH	A, Register
		SUBB	A, Value
		XCH	A, Register
		EndM
;--------------------------------------
CMP_		Macro	Register, Value
		MOV	A, Register
		SUBB	A, Value
		EndM
;--------------------------------------
INC_C?		Macro	Value
		JnC	@@1
		INC	Value
@@1:		EndM
;--------------------------------------
SHR_A		MACRO	Value
		REPT	Value
		RR	A
		ENDR
		ENDM
;--------------------------------------
SHL_A		MACRO	Value
		REPT	Value
		RL	A
		ENDR
		ENDM
;--------------------------------------
Halt		Macro
@@1:		ORL	PCON, #1	;---> Halt
		JMP	@@1
		EndM
;--------------------------------------
MOVC_0		Macro
		CLR	A
		MOVC	A, @A+DPTR
		EndM
;--------------------------------------
MUL_		Macro	ValueA, ValueB
		MOV	A, ValueA
		MOV	B, ValueB
		MUL	AB
		EndM
;--------------------------------------
XorB_		MACRO	BitA, BitB
		Mov	C,  BitA
		Anl	C, /BitB
		Mov	F0, C
		Mov	C,  BitB
		Anl	C, /BitA
		Orl	C, F0
		ENDM
;--------------------------------------
SetB_		MACRO	Register, Value
	Cond	@Register = XSeg
		Mov	R0, #Target
		MovX	A, @R0
		SetB	A.Value
		MovX	@R0,A
	Else
	  Cond	(Register & 7) = 0
		SetB	Register.Value
	  Else
		ORL	Register, #(1 << Value)
	  EndC
	EndC
		EndM
;--------------------------------------
ResB_		MACRO	Register, Value
	Cond	@Register = XSeg
		Mov	R0, #Target
		MovX	A, @R0
		SetB	A.Value
		MovX	@R0,A
	Else
	  Cond	(Register & 7) = 0
		CLR	Register.Value
	  Else
		ANL	Register, #~(1 << Value)
	  EndC
	EndC
		EndM
;--------------------------------------
