;-------------------------------------------------------------------------------
;	RTC Driver for V3021
;	Stand: 20.2.2005
;-------------------------------------------------------------------------------

		Extrn	RTC_WR		;P1.3
		Extrn	RTC_RD		;P1.4
		Extrn	RTC_IO		;P1.5

		Public	RTC_Init
		Public	RTC_Put		;RTC := Data
		Public	RTC_Set		;RTC := Adresse
		Public	RTC_Get		;Data := RTC

;-------------------------------------------------------------------------------
		List	Off
		Include	MACROS.INC
;-------------------------------------------------------------------------------
;		    --_--
;	XTALin	1 -|     |- 8 Vcc
;	32768Hz    |  V  |
;	XTALout	2 -|  3  |- 7 /WR
;		   |  0  |
;	 /CS	3 -|  2  |- 6 /RD
;		   |  1  |
; 	 GND	4 -|     |- 5 I/O
;	            -----        
;-------------------------------------------------------------------------------
;                       s0 s1 | s   m   h | d   m   y | wd  wn
;			0, 1  | 2   3   4 | 5   6   7 | 8   9
TimeTab:	DB	0, 0  ,50H,58H,11H,20H,02H,05H,06H,01H

RTC_Init:	Call	RTC_Get
		CLR	A
		Call	RTC_Set
		Call	RTC_Put
		MOV	R1, #0
		MOV	DPTR, #TimeTab
InitTime1:	mov	A, R1
		Call	RTC_Set
		CLR	A
		MovC	A, @A+DPTR
		Call	RTC_Put
		Inc	DPTR
		Inc	R1
		CJNE	R1, #10, InitTime1
		
		Mov	A, #14		;Copy RAM to Clock
		Call	RTC_Put
		Clr	A
		Call	RTC_Set
		Mov	A, #10H		;Set Lock
;-------------------------------------------------------------------------------
;send Adr/Data to RTC
RTC_Put:	Push	B
	  	Mov	B, #8
		JMP	RTC_PutLoop

RTC_Set:	Push	B
		Mov	B, #4
RTC_PutLoop:	CLR	RTC_WR
	      	RRC	A
		MOV	RTC_IO, C
		NOP
		SetB	RTC_WR
		DJNZ	B, RTC_PutLoop
		SETB	RTC_IO
		Pop	B
		RET
;-------------------------------------------------------------------------------
;read Data from RTC
; A := RTC[A]
RTC_Get:	Call	RTC_Set
		Push	B
		Mov	B, #8
RTC_GetLoop:	Clr	RTC_RD
		NOP
		Mov	C, RTC_IO
		SetB	RTC_RD
		RRC	A
		DJNZ	B, RTC_GetLoop
		Pop	B
		Ret
;-------------------------------------------------------------------------------
		End
